首页 > 代码库 > poj 3126

poj 3126

Prime Path
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 11788 Accepted: 6697

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don‘t know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670

Source

Northwestern Europe 2006
#include <iostream>#include <cmath>#include <queue>using namespace std;const int MAXN = 10000;int prime1, prime2;struct node{        int num;        int step;};bool used[MAXN];bool bPrime[MAXN];void IsPrime(){      bPrime[0] = bPrime[1] = 1;      for(int i=2;i<=10000;i++)          for(int j=i*2;j<=10000;j=j+i)              bPrime[j]=1;}void bfs(){        queue <node> q;        node p, t, head;        while (!q.empty())                q.pop();        head.num = prime1;        head.step = 0;        used[prime1] = true;        q.push(head);        while (!q.empty())        {                p = q.front();                q.pop();                if (p.num == prime2)                {                        printf("%d\n", p.step);                        return;                }                int res, r, k;                // 个位                res = p.num % 10;                for (r = 0; r <= 9; ++r)                {                        k = p.num - res + r;                        if (!used[k] &&! bPrime[k])                        {                                t.num = k;                                t.step = p.step + 1;                                q.push(t);                                used[k] = true;                        }                }                // 十位                res = (p.num / 10) % 10;                for (r = 0; r <= 9; ++r)                {                        k = p.num - res * 10 + r * 10;                        if (!used[k] && !bPrime[k])                        {                                t.num = k;                                t.step = p.step + 1;                                q.push(t);                                used[k] = true;                        }                }                // 百位                res = (p.num / 100) % 10;                for (r = 0; r <= 9; ++r)                {                        k = p.num - res * 100 + r * 100;                        if (!used[k] && !bPrime[k])                        {                                t.num = k;                                t.step = p.step + 1;                                q.push(t);                                used[k] = true;                        }                }                // 千位                res = p.num / 1000;                for (r = 0; r <= 9; ++r)                {                        k = p.num - res * 1000 + r * 1000;                        if (p.num >= 1000)                        {                                if (!used[k] && !bPrime[k])                                {                                        t.num = k;                                        t.step = p.step + 1;                                        q.push(t);                                        used[k] = true;                                }                        }                }        }}int main(){        int nCases;        scanf("%d", &nCases);        IsPrime();        while (nCases--)        {                scanf("%d%d", &prime1, &prime2);                memset(used, false, sizeof(used));                bfs();        }        return 0;}

  

poj 3126